"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const qwik = require("@builder.io/qwik");
const jsxRuntime = require("@builder.io/qwik/jsx-runtime");
const blocks = require("../../components/blocks/blocks.qwik.cjs");
const inlinedScript = require("../../components/inlined-script.qwik.cjs");
const inlinedStyles = require("../../components/inlined-styles.qwik.cjs");
const target = require("../../constants/target.qwik.cjs");
const getClassPropName = require("../../functions/get-class-prop-name.qwik.cjs");
const isEditing = require("../../functions/is-editing.qwik.cjs");
const isPreviewing = require("../../functions/is-previewing.qwik.cjs");
const canTrack = require("../../helpers/canTrack.qwik.cjs");
const userAttributes = require("../../helpers/user-attributes.qwik.cjs");
const helpers = require("./helpers.qwik.cjs");
const inlinedFns = require("./helpers/inlined-fns.qwik.cjs");
const PersonalizationContainer = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  var _a, _b, _c, _d, _e, _f, _g, _h;
  qwik._jsxBranch();
  const attrs = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    const [props2] = qwik.useLexicalScope();
    return {
      ...props2.attributes,
      [getClassPropName.getClassPropName()]: `builder-personalization-container ${props2.attributes[getClassPropName.getClassPropName()] || ""}`
    };
  }, "PersonalizationContainer_component_attrs_useComputed_HvEf55mhkdc", [
    props
  ]));
  const filteredVariants = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    const [props2] = qwik.useLexicalScope();
    return (props2.variants || []).filter((variant) => {
      var _a2, _b2, _c2, _d2;
      return inlinedFns.filterWithCustomTargeting({
        ...((_b2 = (_a2 = props2.builderContext) == null ? void 0 : _a2.rootState) == null ? void 0 : _b2.locale) ? {
          locale: (_d2 = (_c2 = props2.builderContext) == null ? void 0 : _c2.rootState) == null ? void 0 : _d2.locale
        } : {},
        ...state.userAttributes
      }, variant.query, variant.startDate, variant.endDate);
    });
  }, "PersonalizationContainer_component_filteredVariants_useComputed_0jlgEflkxcQ", [
    props
  ]));
  const blocksToRender = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    var _a2;
    const [filteredVariants2, props2] = qwik.useLexicalScope();
    return helpers.getBlocksToRender({
      variants: props2.variants,
      fallbackBlocks: (_a2 = props2.builderBlock) == null ? void 0 : _a2.children,
      isHydrated: state.shouldResetVariants,
      filteredVariants: filteredVariants2.value,
      previewingIndex: props2.previewingIndex
    });
  }, "PersonalizationContainer_component_blocksToRender_useComputed_aZOAYVB7Svg", [
    filteredVariants,
    props
  ]));
  const hideVariantsStyleString = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    const [props2] = qwik.useLexicalScope();
    return (props2.variants || []).map((_, index) => {
      var _a2;
      return `div[data-variant-id="${(_a2 = props2.builderBlock) == null ? void 0 : _a2.id}-${index}"] { display: none !important; } `;
    }).join("");
  }, "PersonalizationContainer_component_hideVariantsStyleString_useComputed_zcfmLIe0H1E", [
    props
  ]));
  const rootRef = qwik.useSignal();
  const state = qwik.useStore({
    scriptStr: helpers.getPersonalizationScript(props.variants, ((_a = props.builderBlock) == null ? void 0 : _a.id) || "none", (_c = (_b = props.builderContext) == null ? void 0 : _b.rootState) == null ? void 0 : _c.locale),
    shouldRenderVariants: helpers.checkShouldRenderVariants(props.variants, canTrack.getDefaultCanTrack((_d = props.builderContext) == null ? void 0 : _d.canTrack)),
    shouldResetVariants: false,
    unsubscribers: [],
    updateVisibilityStylesScript: helpers.getUpdateVisibilityStylesScript(props.variants, ((_e = props.builderBlock) == null ? void 0 : _e.id) || "none", (_g = (_f = props.builderContext) == null ? void 0 : _f.rootState) == null ? void 0 : _g.locale),
    userAttributes: userAttributes.userAttributesService.getUserAttributes()
  });
  qwik.useVisibleTaskQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    var _a2;
    const [filteredVariants2, props2, rootRef2, state2] = qwik.useLexicalScope();
    state2.shouldResetVariants = true;
    const unsub = userAttributes.userAttributesService.subscribeOnUserAttributesChange((attrs2) => {
      state2.userAttributes = attrs2;
    });
    if (!(isEditing.isEditing() || isPreviewing.isPreviewing())) {
      const variant = filteredVariants2.value[0];
      if (rootRef2.value) {
        rootRef2.value.dispatchEvent(new CustomEvent("builder.variantLoaded", {
          detail: {
            variant: variant || helpers.DEFAULT_INDEX,
            content: (_a2 = props2.builderContext) == null ? void 0 : _a2.content
          },
          bubbles: true
        }));
        const observer = new IntersectionObserver((entries) => {
          entries.forEach((entry) => {
            var _a3;
            if (entry.isIntersecting && rootRef2.value)
              rootRef2.value.dispatchEvent(new CustomEvent("builder.variantDisplayed", {
                detail: {
                  variant: variant || helpers.DEFAULT_INDEX,
                  content: (_a3 = props2.builderContext) == null ? void 0 : _a3.content
                },
                bubbles: true
              }));
          });
        });
        observer.observe(rootRef2.value);
      }
    }
    state2.unsubscribers.push(unsub);
  }, "PersonalizationContainer_component_useVisibleTask_Pr6C1pfMwDU", [
    filteredVariants,
    props,
    rootRef,
    state
  ]));
  return /* @__PURE__ */ qwik._jsxS("div", {
    ref: rootRef,
    ...attrs.value,
    children: [
      state.shouldResetVariants && helpers.SDKS_REQUIRING_RESET_APPROACH.includes(target.TARGET) ? /* @__PURE__ */ qwik._jsxC(blocks.Blocks, {
        get blocks() {
          return blocksToRender.value.blocks;
        },
        get parent() {
          var _a2;
          return (_a2 = props.builderBlock) == null ? void 0 : _a2.id;
        },
        get path() {
          return blocksToRender.value.path;
        },
        get context() {
          return props.builderContext;
        },
        get registeredComponents() {
          return props.builderComponents;
        },
        get BlocksWrapperProps() {
          var _a2, _b2;
          return {
            ...(_a2 = props.builderContext) == null ? void 0 : _a2.BlocksWrapperProps,
            "data-variant-id": `${(_b2 = props.builderBlock) == null ? void 0 : _b2.id}-${blocksToRender.value.index}`
          };
        },
        [qwik._IMMUTABLE]: {
          BlocksWrapperProps: qwik._fnSignal((p0, p1) => {
            var _a2, _b2;
            return {
              ...(_a2 = p1.builderContext) == null ? void 0 : _a2.BlocksWrapperProps,
              "data-variant-id": `${(_b2 = p1.builderBlock) == null ? void 0 : _b2.id}-${p0.value.index}`
            };
          }, [
            blocksToRender,
            props
          ], '{...p1.builderContext?.BlocksWrapperProps,"data-variant-id":`${p1.builderBlock?.id}-${p0.value.index}`}'),
          blocks: qwik._fnSignal((p0) => p0.value.blocks, [
            blocksToRender
          ], "p0.value.blocks"),
          context: qwik._fnSignal((p0) => p0.builderContext, [
            props
          ], "p0.builderContext"),
          parent: qwik._fnSignal((p0) => {
            var _a2;
            return (_a2 = p0.builderBlock) == null ? void 0 : _a2.id;
          }, [
            props
          ], "p0.builderBlock?.id"),
          path: qwik._fnSignal((p0) => p0.value.path, [
            blocksToRender
          ], "p0.value.path"),
          registeredComponents: qwik._fnSignal((p0) => p0.builderComponents, [
            props
          ], "p0.builderComponents")
        }
      }, 3, "Xk_0") : null,
      !state.shouldResetVariants && helpers.SDKS_REQUIRING_RESET_APPROACH.includes(target.TARGET) || !helpers.SDKS_REQUIRING_RESET_APPROACH.includes(target.TARGET) ? /* @__PURE__ */ qwik._jsxC(jsxRuntime.Fragment, {
        children: [
          state.shouldRenderVariants ? /* @__PURE__ */ qwik._jsxC(jsxRuntime.Fragment, {
            children: [
              /* @__PURE__ */ qwik._jsxC(inlinedStyles.InlinedStyles, {
                get nonce() {
                  var _a2;
                  return ((_a2 = props.builderContext) == null ? void 0 : _a2.nonce) || "";
                },
                get styles() {
                  return hideVariantsStyleString.value;
                },
                get id() {
                  var _a2;
                  return `variants-styles-${(_a2 = props.builderBlock) == null ? void 0 : _a2.id}`;
                },
                [qwik._IMMUTABLE]: {
                  id: qwik._fnSignal((p0) => {
                    var _a2;
                    return `variants-styles-${(_a2 = p0.builderBlock) == null ? void 0 : _a2.id}`;
                  }, [
                    props
                  ], "`variants-styles-${p0.builderBlock?.id}`"),
                  nonce: qwik._fnSignal((p0) => {
                    var _a2;
                    return ((_a2 = p0.builderContext) == null ? void 0 : _a2.nonce) || "";
                  }, [
                    props
                  ], 'p0.builderContext?.nonce||""'),
                  styles: qwik._fnSignal((p0) => p0.value, [
                    hideVariantsStyleString
                  ], "p0.value")
                }
              }, 3, "Xk_1"),
              /* @__PURE__ */ qwik._jsxC(inlinedScript.InlinedScript, {
                get nonce() {
                  var _a2;
                  return ((_a2 = props.builderContext) == null ? void 0 : _a2.nonce) || "";
                },
                get scriptStr() {
                  return state.updateVisibilityStylesScript;
                },
                get id() {
                  var _a2;
                  return `variants-visibility-script-${(_a2 = props.builderBlock) == null ? void 0 : _a2.id}`;
                },
                [qwik._IMMUTABLE]: {
                  id: qwik._fnSignal((p0) => {
                    var _a2;
                    return `variants-visibility-script-${(_a2 = p0.builderBlock) == null ? void 0 : _a2.id}`;
                  }, [
                    props
                  ], "`variants-visibility-script-${p0.builderBlock?.id}`"),
                  nonce: qwik._fnSignal((p0) => {
                    var _a2;
                    return ((_a2 = p0.builderContext) == null ? void 0 : _a2.nonce) || "";
                  }, [
                    props
                  ], 'p0.builderContext?.nonce||""'),
                  scriptStr: qwik._fnSignal((p0) => p0.updateVisibilityStylesScript, [
                    state
                  ], "p0.updateVisibilityStylesScript")
                }
              }, 3, "Xk_2"),
              (props.variants || []).map((variant, index) => {
                var _a2, _b2, _c2, _d2;
                return /* @__PURE__ */ qwik._jsxC(blocks.Blocks, {
                  BlocksWrapperProps: {
                    ...(_a2 = props.builderContext) == null ? void 0 : _a2.BlocksWrapperProps,
                    "aria-hidden": true,
                    hidden: true,
                    "data-variant-id": `${(_b2 = props.builderBlock) == null ? void 0 : _b2.id}-${index}`
                  },
                  get blocks() {
                    return variant.blocks;
                  },
                  get parent() {
                    var _a3;
                    return (_a3 = props.builderBlock) == null ? void 0 : _a3.id;
                  },
                  path: `component.options.variants.${index}.blocks`,
                  get context() {
                    return props.builderContext;
                  },
                  get registeredComponents() {
                    return props.builderComponents;
                  },
                  children: /* @__PURE__ */ qwik._jsxC(inlinedScript.InlinedScript, {
                    get nonce() {
                      var _a3;
                      return ((_a3 = props.builderContext) == null ? void 0 : _a3.nonce) || "";
                    },
                    get scriptStr() {
                      return state.scriptStr;
                    },
                    id: `variants-script-${(_c2 = props.builderBlock) == null ? void 0 : _c2.id}-${index}`,
                    [qwik._IMMUTABLE]: {
                      nonce: qwik._fnSignal((p0) => {
                        var _a3;
                        return ((_a3 = p0.builderContext) == null ? void 0 : _a3.nonce) || "";
                      }, [
                        props
                      ], 'p0.builderContext?.nonce||""'),
                      scriptStr: qwik._fnSignal((p0) => p0.scriptStr, [
                        state
                      ], "p0.scriptStr")
                    }
                  }, 3, "Xk_3"),
                  [qwik._IMMUTABLE]: {
                    blocks: qwik._wrapProp(variant, "blocks"),
                    context: qwik._fnSignal((p0) => p0.builderContext, [
                      props
                    ], "p0.builderContext"),
                    parent: qwik._fnSignal((p0) => {
                      var _a3;
                      return (_a3 = p0.builderBlock) == null ? void 0 : _a3.id;
                    }, [
                      props
                    ], "p0.builderBlock?.id"),
                    registeredComponents: qwik._fnSignal((p0) => p0.builderComponents, [
                      props
                    ], "p0.builderComponents")
                  }
                }, 1, `${(_d2 = props.builderBlock) == null ? void 0 : _d2.id}-${index}`);
              })
            ]
          }, 1, "Xk_4") : null,
          /* @__PURE__ */ qwik._jsxC(blocks.Blocks, {
            get blocks() {
              return blocksToRender.value.blocks;
            },
            get parent() {
              var _a2;
              return (_a2 = props.builderBlock) == null ? void 0 : _a2.id;
            },
            get path() {
              return blocksToRender.value.path;
            },
            get context() {
              return props.builderContext;
            },
            get registeredComponents() {
              return props.builderComponents;
            },
            get BlocksWrapperProps() {
              var _a2, _b2;
              return {
                ...(_a2 = props.builderContext) == null ? void 0 : _a2.BlocksWrapperProps,
                "data-variant-id": `${(_b2 = props.builderBlock) == null ? void 0 : _b2.id}-${blocksToRender.value.index}`
              };
            },
            children: state.shouldRenderVariants ? /* @__PURE__ */ qwik._jsxC(inlinedScript.InlinedScript, {
              get nonce() {
                var _a2;
                return ((_a2 = props.builderContext) == null ? void 0 : _a2.nonce) || "";
              },
              get scriptStr() {
                return state.scriptStr;
              },
              id: `variants-script-${(_h = props.builderBlock) == null ? void 0 : _h.id}-${helpers.DEFAULT_INDEX}`,
              [qwik._IMMUTABLE]: {
                nonce: qwik._fnSignal((p0) => {
                  var _a2;
                  return ((_a2 = p0.builderContext) == null ? void 0 : _a2.nonce) || "";
                }, [
                  props
                ], 'p0.builderContext?.nonce||""'),
                scriptStr: qwik._fnSignal((p0) => p0.scriptStr, [
                  state
                ], "p0.scriptStr")
              }
            }, 3, "Xk_5") : null,
            [qwik._IMMUTABLE]: {
              BlocksWrapperProps: qwik._fnSignal((p0, p1) => {
                var _a2, _b2;
                return {
                  ...(_a2 = p1.builderContext) == null ? void 0 : _a2.BlocksWrapperProps,
                  "data-variant-id": `${(_b2 = p1.builderBlock) == null ? void 0 : _b2.id}-${p0.value.index}`
                };
              }, [
                blocksToRender,
                props
              ], '{...p1.builderContext?.BlocksWrapperProps,"data-variant-id":`${p1.builderBlock?.id}-${p0.value.index}`}'),
              blocks: qwik._fnSignal((p0) => p0.value.blocks, [
                blocksToRender
              ], "p0.value.blocks"),
              context: qwik._fnSignal((p0) => p0.builderContext, [
                props
              ], "p0.builderContext"),
              parent: qwik._fnSignal((p0) => {
                var _a2;
                return (_a2 = p0.builderBlock) == null ? void 0 : _a2.id;
              }, [
                props
              ], "p0.builderBlock?.id"),
              path: qwik._fnSignal((p0) => p0.value.path, [
                blocksToRender
              ], "p0.value.path"),
              registeredComponents: qwik._fnSignal((p0) => p0.builderComponents, [
                props
              ], "p0.builderComponents")
            }
          }, 1, "Xk_6")
        ]
      }, 1, "Xk_7") : null
    ]
  }, null, 0, "Xk_8");
}, "PersonalizationContainer_component_kIsPnu9O2Ew"));
exports.PersonalizationContainer = PersonalizationContainer;
exports.default = PersonalizationContainer;
