import { BuilderBlock } from "../../types/builder-block";
export type BlocksWrapperProps = {
    blocks: BuilderBlock[] | undefined;
    parent: string | undefined;
    path: string | undefined;
    styleProp: Record<string, any> | undefined;
    /**
     * The element that wraps each list of blocks. Defaults to a `div` element ('ScrollView' in React Native).
     */
    BlocksWrapper: any;
    /**
     * Props to be applied to the wrapping element of blocks. Can be set in two ways:
     * 1. Globally via `<Content blocksWrapperProps={{...}}/>` - applies to all blocks wrappers in the Content
     * 2. Locally via `<Blocks BlocksWrapperProps={{...}}/>` - applies only to this specific blocks instance and overrides global props
     *
     * For merging both global and local props, spread the context props before adding your own:
     * ```
     * <Blocks
     *   BlocksWrapperProps={{
     *     ...builderContext.BlocksWrapperProps,
     *     'data-test-id': 'my-test-id'
     *   }}
     * />
     * ```
     */
    BlocksWrapperProps: any;
    children?: any;
    classNameProp?: string;
};
export declare const onClick: (props: any, state: any, className: any, dataPath: any, blocksWrapperRef: any) => void;
export declare const onMouseEnter: (props: any, state: any, className: any, dataPath: any, blocksWrapperRef: any) => void;
export declare const BlocksWrapper: import("@builder.io/qwik").Component<BlocksWrapperProps>;
export default BlocksWrapper;
export declare const STYLES = "\n.props-blocks-wrapper-BlocksWrapper {\n  display: flex;\n  flex-direction: column;\n  align-items: stretch;\n}\n";
